diff -uwr sourceold/tdbedit/tdbedit.cpp source/tdbedit/tdbedit.cpp
--- sourceold/tdbedit/tdbedit.cpp	2011-10-11 23:02:44.485351500 +0800
+++ source/tdbedit/tdbedit.cpp	2012-05-02 01:23:03.404296800 +0800
@@ -20,6 +20,10 @@
 #include "search.h"
 #include "RawFileClass.h"
 #include "SaveLoadSystemClass.h"
+#include "SList.h"
+#include "PresetMgr.h"
+#include "DefinitionMgrClass.h"
+#include "AudibleSoundDefinitionClass.h"
 
 #define CLASS_NAME L"TDB_WND"
 #define WND_TITLE L"Advanced string editor"
@@ -189,7 +193,46 @@
 	SetWindowText(g_MainWnd, lBuf);
 	return true;
 }
+bool presetloaded = false;
+bool OpenDDBFile()
+{
+	wchar_t lBuf[MAX_PATH] = L"";
+	OPENFILENAME of;
+
+	memset(&of, 0, sizeof(OPENFILENAME));
+
+	of.lStructSize = sizeof(OPENFILENAME);
+	of.hwndOwner = g_MainWnd;
+	of.hInstance = NULL;
+	of.lpstrFilter = L"Preset Database\0*.ddb\0\0";
+	of.lpstrCustomFilter = NULL;
+	of.nMaxCustFilter = 0;
+	of.nFilterIndex = 0;
+	of.lpstrFile = lBuf;
+	of.nMaxFile = MAX_PATH;
+	of.lpstrFileTitle = NULL;
+	of.nMaxFileTitle = 0;
+	of.lpstrInitialDir = NULL;
+	of.lpstrTitle = NULL;
+	of.Flags = OFN_FILEMUSTEXIST;
+	of.nFileOffset = 0;
+	of.nFileExtension = 0;
+	of.lpstrDefExt = NULL;
+	of.lCustData = NULL;
+	of.lpfnHook = NULL;
+	of.lpTemplateName = NULL;	
 
+	if (!GetOpenFileName(&of)) return false;
+	char fn[MAX_PATH] = "";
+	wcstombs(fn,of.lpstrFile,MAX_PATH);
+	RawFileClass file(fn);
+	file.Open(1);
+	ChunkLoadClass chunkLoader(&file);
+	SaveLoadSystemClass::Load(chunkLoader, true);
+	file.Close();
+	presetloaded = true;
+	return true;
+}
 
 bool SaveFile(wchar_t *buf, int bufsize, int *FileOffset, int *ExtensionOffset)
 {
@@ -496,8 +539,23 @@
 		unsigned int id = o->Get_Sound_ID();
 		if (id != 0xFFFFFFFF)
 		{
+			if (presetloaded)
+			{
+				PresetClass *preset = PresetMgrClass::Find_Preset(id);
+				if (preset && preset->Get_Definition() && preset->Get_Definition()->Get_Name())
+				{
+					_snwprintf(lBuf, 256, L"%S", preset->Get_Definition()->Get_Name());
+				}
+				else
+				{
+					_snwprintf(lBuf, 256, L"%s", L"");
+				}
+			}
+			else
+			{
 			_snwprintf(lBuf, 256, L"%d", id);
 		}
+		}
 		else
 		{
 			_snwprintf(lBuf, 256, L"%s", L"");
@@ -541,11 +599,11 @@
 	col.pszText = L"ID (numeric)";
 	SendMessage(g_StringList, LVM_INSERTCOLUMN, (WPARAM)1, (LPARAM)&col);
 
-	col.cx = 100;
+	col.cx = 200;
 	col.pszText = L"Sound ID";
 	SendMessage(g_StringList, LVM_INSERTCOLUMN, (WPARAM)2, (LPARAM)&col);
 
-	col.cx = 450;
+	col.cx = 500;
 	col.pszText = L"English text";
 	SendMessage(g_StringList, LVM_INSERTCOLUMN, (WPARAM)3, (LPARAM)&col);
 	TCITEM item;
@@ -634,6 +692,10 @@
 			case ID_OPEN:
 				Do_Open();
 				break;
+			case ID_OPEN_DDB:
+				OpenDDBFile();
+				Handle_Tab_Change((int)SendMessage(g_Tabs, TCM_GETCURSEL, 0, 0));
+				break;
 			case ID_SAVE:
 				if (filename)
 				{
@@ -908,7 +970,7 @@
 	atm = RegisterClassEx(&wcls);
 
 	g_MainWnd = CreateWindowEx(0, CLASS_NAME, WND_TITLE, 
-		WS_OVERLAPPEDWINDOW | WS_VISIBLE, CW_USEDEFAULT, CW_USEDEFAULT, 800, 600, NULL, 
+		WS_OVERLAPPEDWINDOW | WS_VISIBLE, CW_USEDEFAULT, CW_USEDEFAULT, 1024, 768, NULL, 
 		NULL, g_hInstance, NULL);
 
 	if (g_MainWnd)
@@ -934,17 +996,26 @@
 bool SaveLoadSystemClass::Load(ChunkLoadClass& chunkLoader, bool auto_post_load)
 {
 	SaveLoadSystemClass::PointerRemapper.Reset();
+
 	bool allSucceeded = true;
+
 	for (; chunkLoader.Open_Chunk(); chunkLoader.Close_Chunk())
 	{
+		// DEPRECATED: SaveLoadStatus::Inc_Status_Count();
 		SaveLoadSubSystemClass* subSystem = SaveLoadSystemClass::Find_Sub_System (chunkLoader.Cur_Chunk_ID());
 		if (subSystem)
 		{
+		   // SaveLoadStatus::Set_Status_Text (subSystem->Name(), 1);
 		   allSucceeded = allSucceeded && subSystem->Load (chunkLoader);
 		}
 	}
+
 	SaveLoadSystemClass::PointerRemapper.Process();
 	SaveLoadSystemClass::PointerRemapper.Reset();
+
+   if (auto_post_load)
+      SaveLoadSystemClass::Post_Load_Processing (0);
+
 	return allSucceeded;
 }
 
@@ -959,3 +1030,23 @@
 	}
 	return false;
 }
+
+SList<PostLoadableClass> PostLoadList;
+
+void SaveLoadSystemClass::Post_Load_Processing(void(*func)())
+{
+	for (PostLoadableClass *post = PostLoadList.Remove_Head();post;post = PostLoadList.Remove_Head())
+	{
+		post->On_Post_Load();
+		post->Set_Post_Load_Registered(false);
+	}
+}
+
+void SaveLoadSystemClass::Register_Post_Load_Callback(PostLoadableClass *post)
+{
+	if (!post->Is_Post_Load_Registered())
+	{
+		post->Set_Post_Load_Registered(true);
+		PostLoadList.Add_Head(post);
+	}
+}
diff -uwr sourceold/tdbedit/tdbedit.rc source/tdbedit/tdbedit.rc
--- sourceold/tdbedit/tdbedit.rc	2009-12-25 08:41:14.171057800 +0800
+++ source/tdbedit/tdbedit.rc	2012-05-01 23:28:59.558593700 +0800
@@ -16,10 +16,8 @@
 // German (Germany) resources
 
 #if !defined(AFX_RESOURCE_DLL) || defined(AFX_TARG_DEU)
-#ifdef _WIN32
 LANGUAGE LANG_GERMAN, SUBLANG_GERMAN
 #pragma code_page(1252)
-#endif //_WIN32
 
 #ifdef APSTUDIO_INVOKED
 /////////////////////////////////////////////////////////////////////////////
@@ -64,6 +62,7 @@
         MENUITEM "Export C Header",             ID_EXPORT_HEADER, GRAYED
         MENUITEM "Import Table",                ID_IMPORT_TABLE
         MENUITEM "Export Table",                ID_EXPORT_TABLE, GRAYED
+        MENUITEM "Open DDB",                    ID_OPEN_DDB
         MENUITEM SEPARATOR
         MENUITEM "Exit",                        ID_EXIT
     END
@@ -155,7 +154,7 @@
     LTEXT           "ID",IDC_STATIC,6,6,36,12
     EDITTEXT        IDC_ANIMATION,42,24,300,12,ES_AUTOHSCROLL | NOT WS_BORDER,WS_EX_STATICEDGE
     LTEXT           "Animation",IDC_STATIC,6,24,36,12
-    EDITTEXT        IDC_SOUND_ID,42,42,300,12,ES_AUTOHSCROLL | NOT WS_BORDER,WS_EX_STATICEDGE
+    EDITTEXT        IDC_SOUND_ID,42,42,244,12,ES_AUTOHSCROLL | NOT WS_BORDER,WS_EX_STATICEDGE
     LTEXT           "Sound",IDC_STATIC,6,42,36,12
     EDITTEXT        IDC_TEXT,42,78,300,42,ES_MULTILINE | ES_AUTOVSCROLL | ES_WANTRETURN | NOT WS_BORDER | WS_VSCROLL,WS_EX_STATICEDGE
     LTEXT           "Text",IDC_STATIC,6,78,36,12
@@ -164,6 +163,7 @@
     LTEXT           "Eng. string",IDC_STATIC,6,60,36,12
     EDITTEXT        IDC_ID_N,264,6,78,12,ES_AUTOHSCROLL | NOT WS_BORDER,WS_EX_STATICEDGE
     PUSHBUTTON      "Cancel",IDCANCEL,60,126,50,14,BS_FLAT
+    PUSHBUTTON      "&Sound",IDSOUND,289,41,50,14,BS_FLAT
 END
 
 IDD_New_Category DIALOGEX 0, 0, 148, 42
@@ -250,10 +250,39 @@
 // English (Australia) resources
 
 #if !defined(AFX_RESOURCE_DLL) || defined(AFX_TARG_ENA)
-#ifdef _WIN32
 LANGUAGE LANG_ENGLISH, SUBLANG_ENGLISH_AUS
 #pragma code_page(1252)
-#endif //_WIN32
+
+/////////////////////////////////////////////////////////////////////////////
+//
+// Dialog
+//
+
+IDD_SOUNDLIST DIALOGEX 0, 0, 243, 266
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION | WS_SYSMENU
+CAPTION "Dialog"
+FONT 8, "MS Shell Dlg", 400, 0, 0x1
+BEGIN
+    CONTROL         "",IDC_TREE,"SysTreeView32",TVS_HASBUTTONS | TVS_HASLINES | TVS_LINESATROOT | TVS_DISABLEDRAGDROP | TVS_SHOWSELALWAYS | WS_BORDER | WS_HSCROLL | WS_TABSTOP,7,42,229,198
+    DEFPUSHBUTTON   "OK",IDOK,34,245,50,14
+    PUSHBUTTON      "Cancel",IDCANCEL,97,245,50,14
+END
+
+
+/////////////////////////////////////////////////////////////////////////////
+//
+// DESIGNINFO
+//
+
+#ifdef APSTUDIO_INVOKED
+GUIDELINES DESIGNINFO
+BEGIN
+    IDD_SOUNDLIST, DIALOG
+    BEGIN
+    END
+END
+#endif    // APSTUDIO_INVOKED
+
 
 /////////////////////////////////////////////////////////////////////////////
 //
diff -uwr sourceold/tdbedit/tdbedit.vcxproj source/tdbedit/tdbedit.vcxproj
--- sourceold/tdbedit/tdbedit.vcxproj	2011-11-26 13:17:41.689453100 +0800
+++ source/tdbedit/tdbedit.vcxproj	2012-05-28 13:38:15.372664100 +0800
@@ -123,7 +123,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
@@ -185,7 +185,13 @@
     <ClCompile Include="..\scripts\engine_string.cpp" />
     <ClCompile Include="..\scripts\PersistFactoryClass.cpp" />
     <ClCompile Include="..\scripts\PointerRemapClass.cpp" />
+    <ClCompile Include="..\scripts\PresetMgr.cpp" />
+    <ClCompile Include="..\scripts\Random2Class.cpp" />
+    <ClCompile Include="..\scripts\Random3Class.cpp" />
+    <ClCompile Include="..\scripts\RandomClass.cpp" />
+    <ClCompile Include="..\scripts\SysTimeClass.cpp" />
     <ClCompile Include="..\scripts\TDBObjClass.cpp" />
+    <ClCompile Include="..\scripts\TwiddlerClass.cpp" />
     <ClCompile Include="general.cpp">
       <PrecompiledHeader Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">Create</PrecompiledHeader>
       <PrecompiledHeaderFile Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">General.h</PrecompiledHeaderFile>
@@ -205,6 +211,7 @@
     <ResourceCompile Include="tdbedit.rc" />
   </ItemGroup>
   <ItemGroup>
+    <ClInclude Include="..\scripts\PresetMgr.h" />
     <ClInclude Include="general.h" />
     <ClInclude Include="resource.h" />
   </ItemGroup>
diff -uwr sourceold/tdbedit/tdbedit.vcxproj.filters source/tdbedit/tdbedit.vcxproj.filters
--- sourceold/tdbedit/tdbedit.vcxproj.filters	2010-12-11 11:30:06.640625000 +0800
+++ source/tdbedit/tdbedit.vcxproj.filters	2012-05-01 21:44:08.549804600 +0800
@@ -65,6 +65,24 @@
     <ClCompile Include="..\scripts\TDBObjClass.cpp">
       <Filter>01. Sources</Filter>
     </ClCompile>
+    <ClCompile Include="..\scripts\TwiddlerClass.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="..\scripts\PresetMgr.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="..\scripts\SysTimeClass.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="..\scripts\RandomClass.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="..\scripts\Random2Class.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
+    <ClCompile Include="..\scripts\Random3Class.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
   </ItemGroup>
   <ItemGroup>
     <None Include="icon.ico">
@@ -83,5 +101,8 @@
     <ClInclude Include="resource.h">
       <Filter>Include Files</Filter>
     </ClInclude>
+    <ClInclude Include="..\scripts\PresetMgr.h">
+      <Filter>01. Sources</Filter>
+    </ClInclude>
   </ItemGroup>
 </Project>
\ No newline at end of file
diff -uwr sourceold/teamspeak/teamspeak.vcxproj source/teamspeak/teamspeak.vcxproj
--- sourceold/teamspeak/teamspeak.vcxproj	2011-11-26 13:17:35.861328100 +0800
+++ source/teamspeak/teamspeak.vcxproj	2012-05-28 13:38:15.093367300 +0800
@@ -153,7 +153,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
